SCANDIRAT(3)

NAME
scandirat - scan a directory relative to a directory file descriptor

SYNOPSIS
#define _GNU_SOURCE         /* See feature_test_macros(7) */
#include <fcntl.h>          /* Definition of AT_* constants */
#include <dirent.h>

int scandirat(int dirfd, const char *dirp, struct dirent ***namelist,
    int (*filter)(const struct dirent *),
    int (*compar)(const struct dirent **, const struct dirent **));

DESCRIPTION
The scandirat() system call operates in exactly the same way as scandir(3), except for the differences described in this manual page. If the pathname given in dirp is relative, then it is interpreted relative to the directory referred to by the file descriptor dirfd (rather than relative to the current working directory of the calling process, as is done by scandir(3) for a relative pathname). If dirp is relative and dirfd is the special value AT_FDCWD, then dirp is interpreted relative to the current working directory of the calling process (like scandir(3)). If dirp is absolute, then dirfd is ignored.

RETURN VALUE
On success, scandirat() returns the number of directory entries selected. On error, -1 is returned and errno is set to indicate the error.

ERRORS
The same errors that occur for scandir(3) can also occur for scandirat(). The following additional errors can occur for scandirat():

EBADF
    dirfd is not a valid file descriptor.

ENOTDIR
    dirp is a relative path and dirfd is a file descriptor referring to a file other than a directory.

VERSIONS
scandirat() was added to glibc in version 2.15.

CONFORMING TO
This function is a GNU extension.

NOTES
See openat(2) for an explanation of the need for scandirat().

SEE ALSO
openat(2), scandir(3), path_resolution(7)

COLOPHON
This page is part of release 3.57 of the Linux man-pages project. A description of the project, and information about reporting bugs, can be found at http://www.kernel.org/doc/man-pages/.